// Fragment Shader  file "boostzone.frag"

#version 130

precision highp float; // needed only for version 1.30

//in  vec3 ex_Color;
in	vec2 ex_TexCoord0;
in vec4 projcord;

in  vec3 ex_Normal;

in vec3 fragmentNormal;
in vec4 fragmentPos;
in vec3 lightDir;
in vec3 lightPos;

out vec4 out_Color;

uniform sampler2D sTex0;
uniform sampler2D spectex;
uniform sampler2D shadowmap;
uniform vec3 eyepos;

void main(void)
{
	float diffuseIntensity;
	float specular = 0.0;
	float specularIntensity; 

	vec3 light;
	vec3 normal;

	light = normalize(lightPos-normalize(fragmentPos.xyz));

	normal = normalize(fragmentNormal);
	
	diffuseIntensity = max(dot(normal, light), 0.0);


	specularIntensity = texture(spectex, ex_TexCoord0).r;
	
	if(specularIntensity > 0.0){
		vec3 eye = normalize(eyepos - fragmentPos.xyz);
		vec3 halfWay = normalize(light + eye);
		float spec = max(0.0, dot(normal, halfWay));
		specular = pow(spec, 50.0);
		specular*=specularIntensity;
    }
  


	out_Color =texture(sTex0, ex_TexCoord0)*0.2+ texture(sTex0, ex_TexCoord0)*diffuseIntensity + vec4(1.0, 1.0,1.0, 1.0)*specular;


}
