// Vertex Shader  file "boostzone.vert"

#version 130


in  vec3 in_Position;
in	vec2 in_Tex;
in  vec3 in_Normals;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

uniform mat4 LightprojectionMatrix;
uniform mat4 LightviewMatrix;

uniform mat4 modelMatrix;
uniform vec3 lightpos;


out vec2 ex_TexCoord0;
out vec3 fragmentNormal;
out vec4 fragmentPos;
out vec3 lightDir;
out vec3 lightPos;
out vec4 projcord;

void main(void)
{

	mat4 modelview = viewMatrix*modelMatrix;
	mat4 lightmodelview = LightviewMatrix*modelMatrix;

	fragmentNormal = (modelMatrix*vec4(in_Normals, 0.0)).xyz;
	
	fragmentPos = modelMatrix*vec4(in_Position, 1.0);
	
	lightDir = normalize(lightpos-fragmentPos.xyz);
	lightPos = lightpos;
	
	
	gl_Position =projectionMatrix*modelview*vec4(in_Position, 1.0);
	
	
	projcord = LightprojectionMatrix*lightmodelview*vec4(in_Position, 1.0);

	
	ex_TexCoord0 = in_Tex;
	
}
