// Vertex Shader  file "instancing.vert"

#version 140

in vec3 in_Position;
in vec2 in_Tex;
in vec3 in_Normals;


uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrices[50];

uniform mat4 LightprojectionMatrix;
uniform mat4 LightviewMatrix;

uniform vec3 lightpos;

out vec2 ex_TexCoord0;
out vec3 fragmentNormal;
out vec3 fragmentPos;
out vec3 lightDir;
out vec3 lightPos;
out vec4 projcord;

void main(void)
{

	/*
	mat4 modelview = viewMatrix*modelMatrices[1];
	fragmentNormal = (modelMatrices[1]*vec4(in_Normals, 0.0)).xyz;
	fragmentPos = (modelMatrices[1]*vec4(in_Position, 1.0)).xyz;
*/

	mat4 modelview = viewMatrix*modelMatrices[gl_InstanceID];
	mat4 lightmodelview = LightviewMatrix*modelMatrices[gl_InstanceID];

	fragmentNormal = (modelMatrices[gl_InstanceID]*vec4(in_Normals, 0.0)).xyz;
	fragmentPos = (modelMatrices[gl_InstanceID]*vec4(in_Position, 1.0)).xyz;
	

	lightDir = normalize(lightpos-fragmentPos);
	
	lightPos=lightpos;
	

	fragmentPos = normalize(fragmentPos);
	
	gl_Position =projectionMatrix*modelview*vec4(in_Position, 1.0);

	projcord = LightprojectionMatrix*lightmodelview*vec4(in_Position, 1.0);
	
	ex_TexCoord0 = in_Tex;

}
