// Vertex Shader  file "minimal.vert"

#version 130


in  vec3 in_Position;
in	vec2 in_Tex;
in  vec3 in_Normals;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;



uniform mat4 modelMatrix;
uniform vec3 lightpos;


out	vec2 ex_TexCoord0;
out vec3 fragmentNormal;
out vec4 fragmentPos;


void main(void)
{

	mat4 modelview = viewMatrix*modelMatrix;
	
	
	fragmentPos = projectionMatrix*modelview*vec4(in_Position, 1.0);
	
	fragmentNormal = in_Normals;
	
	gl_Position = fragmentPos;

}
