// Fragment Shader  file "minimal.frag"

#version 130

precision highp float; // needed only for version 1.30

//in  vec3 ex_Color;
in	vec2 ex_TexCoord0;
in vec4 projcord;

in  vec3 ex_Normal;

in vec3 fragmentNormal;
in vec4 fragmentPos;
in vec3 lightDir;
in vec3 lightPos;

out vec4 out_Color;

uniform sampler2D sTex0;
uniform sampler2D spectex;
uniform sampler2D shadowmap;
uniform vec3 eyepos;

void main(void)
{
	float diffuseIntensity;
	float specular = 0.0;
	float specularIntensity; 

	vec3 light;
	vec3 normal;

	light = normalize(lightPos-normalize(fragmentPos.xyz));

	normal = normalize(fragmentNormal);
	
	diffuseIntensity = max(dot(normal, light), 0.0);


	specularIntensity = texture(spectex, ex_TexCoord0).r;
	
	if(specularIntensity > 0.0){
		vec3 eye = normalize(eyepos - fragmentPos.xyz);
		vec3 halfWay = normalize(light + eye);
		float spec = max(0.0, dot(normal, halfWay));
		specular = pow(spec, 50.0);
		specular*=specularIntensity;
    }
  
     
	/*
    //specular = specular_color * factor;
    
    light=normalize(vec3(0.0, -100.0, 0.0));

	vec3 reflection = normalize(-reflect(light, normal));
	//specularItensity = pow(clamp(max(dot(reflection, eye), 0.0), 0.0, 1.0), 20.0 );
	specularItensity = pow(max(dot(reflection, eye), 0.0), 256.0 );
	 */


	vec2 projected = vec2((projcord.x/projcord.w)*0.5+0.5,(projcord.y/projcord.w)*0.5+0.5);
	float depth = projcord.z/projcord.w-0.01;

	if(texture(shadowmap, projected).r < depth ){
		//in shadow
		vec4 color =texture(sTex0, ex_TexCoord0)*0.2+ texture(sTex0, ex_TexCoord0)*diffuseIntensity + vec4(1.0, 1.0,1.0, 1.0)*specular;
		if(diffuseIntensity> 0.1){
			color*=0.4;
		}
		out_Color = color;
		//out_Color =texture(shadowmap, projected)*0.9+texture2D(sTex0, ex_TexCoord0)*0.1;
	}
	else{
		out_Color =texture(sTex0, ex_TexCoord0)*0.2+ texture2D(sTex0, ex_TexCoord0)*diffuseIntensity + vec4(1.0, 1.0,1.0, 1.0)*specular;
		//out_Color =texture2D(shadowmap, projected)*0.9+texture2D(sTex0, ex_TexCoord0)*0.1;
	}

	//out_Color =texture2D(sTex0, ex_TexCoord0)*0.2+ texture2D(sTex0, ex_TexCoord0)*diffuseIntensity + vec4(1.0, 1.0,1.0, 1.0)*specularItensity;
	
	//out_Color =vec4(texture2D(shadowmap, ex_TexCoord0).r);

	//out_Color =texture2D(sTex0, ex_TexCoord0)*0.1+ + vec4(1.0, 1.0, 1.0, 1.0)*specularItensity;

	//out_Color = texture2D(sTex0, ex_TexCoord0);
	
	//out_Color = vec4(ex_Color,1.0);
}
