// Fragment Shader  file "post_bloom.frag"

#version 130

precision highp float; // needed only for version 1.30

in	vec2 ex_TexCoord0;
out vec4 out_Color;

uniform sampler2D sTexColor;
uniform sampler2D sTexBloom;
uniform int enableBloom;
uniform float width;

// convert an rgb value to lumincane with the 1/3 conversion model
float rgbToGray(vec4 color)
{
	return 0.333 * color.r + 0.333 * color.g + 0.334 * color.b;
}

void main(void)
{
	vec4 bloom = vec4(0, 0, 0, 0);
	out_Color = texture(sTexColor, ex_TexCoord0);
	
	if (enableBloom == 1)
	{
		float spread = 9.3;
		float[15] weights = float[15](0.00044, 0.00222, 0.00876, 0.02700, 0.06476, 0.12099, 0.17603, 0.19947, 0.17603, 0.12099, 0.06476, 0.02700, 0.00876, 0.00222, 0.00044);
		vec4 bloom = vec4(0, 0, 0, 1);
		for (int i = -7; i < 8; i++)
		{
			vec4 color = texture(sTexBloom, vec2(ex_TexCoord0.x + (i * spread/width), ex_TexCoord0.y));
			bloom += color * weights[i+7];
		}

		out_Color += 0.2 * bloom;
	}
}