// Vertex Shader  file "shadowmapinstancing.vert"

#version 140


in  vec3 in_Position;
in	vec2 in_Tex;
in  vec3 in_Normals;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrices[50];
uniform mat4 modelMatrix;

uniform vec3 lightpos;
uniform float instancing; 


out	vec2 ex_TexCoord0;
out vec3 fragmentNormal;
out vec4 fragmentPos;


void main(void)
{

	mat4 modelview;

	if(instancing < 0.5){
		modelview = viewMatrix*modelMatrix;
	}
	else{
		modelview = viewMatrix*modelMatrices[gl_InstanceID];
	}
	

//mat4 modelview = viewMatrix*modelMatrices[gl_InstanceID];
	
	fragmentPos = projectionMatrix*modelview*vec4(in_Position, 1.0);
	
	fragmentNormal = in_Normals;
	
	gl_Position = fragmentPos;

}
