// Fragment Shader  file "skybox.vert"

#version 130

in vec3 in_Position;
in vec2 in_Tex;
in vec3 in_Normals;

out vec2 ex_TexCoord0;
out vec3 ex_Normal;


uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrix;


void main(void)
{

	mat4 modelview = viewMatrix*modelMatrix;
	
	ex_Normal = in_Normals;
	
	gl_Position =projectionMatrix*modelview*vec4(in_Position, 1.0);
	
	ex_TexCoord0 = in_Tex;

}
